local STARTTIME = 6 * TICRATE + (3 * TICRATE / 4)

local autoaccel = CV_RegisterVar({
	name = "autoaccel",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})

addHook("PlayerCmd", function(p, cmd)
	if p.spectator then return end
	if not autoaccel.value then return end
	if (not p.mo) or (not p.mo.valid) then return end
	if p.exiting or (p.pflags & PF_TIMEOVER) then return end
	if p.cmd.buttons & BT_BRAKE then
		if p.cmd.buttons & BT_DRIFT or p.kartstuff[k_sneakertimer] then
			cmd.forwardmove = 25<<FRACBITS>>16
			cmd.buttons = $ | BT_ACCELERATE
		else
			if cmd.forwardmove > 0 then
				cmd.forwardmove = 0<<FRACBITS>>16
			end
			cmd.buttons = $ & ~BT_ACCELERATE
		end
	else
		cmd.forwardmove = 50<<FRACBITS>>16
	end
	if leveltime > STARTTIME and not p.kartstuff[k_respawn] then cmd.buttons = $ | BT_ACCELERATE end
end)