rawset(_G, "SPLITS", 3)
print('\141"Splits" v'..SPLITS..' - a Tyron thing')

local yelled = false
local init = false
local save
local SAVEFILE_BASE = "splits"
local SAVEFILE_EXT = ".sav2"
local SAVEFILE = SAVEFILE_BASE..SAVEFILE_EXT
local STARTTIME = 6 * TICRATE + (3 * TICRATE / 4)

local runs = {
	{
		name = "Current Map Rotation",
		file = "",
		maps = {"MAP01","MAP02","MAP03","MAP04","MAP05","MAP06","MAP07","MAP08","MAP09","MAP10","MAP11","MAP12","MAP13","MAP14","MAP15","MAP16","MAP17","MAP18","MAP19","MAP20","MAP21","MAP22","MAP23","MAP24","MAP25","MAP26","MAP27","MAP28","MAP29","MAP30","MAP31","MAP32","MAP33","MAP34","MAP35","MAP36","MAP37","MAP38","MAP39","MAP40","MAP41","MAP42","MAP43","MAP44","MAP45","MAP46","MAP47","MAP48","MAP49","MAP50","MAP51","MAP52","MAP53","MAP54","MAP55","MAP56","MAP57","MAP58","MAP59","MAP60"}
	},
		{
		name = "40 Tracks / Original Courses",
		file = "40tracks",
		maps = {"MAP01","MAP02","MAP03","MAP04","MAP05","MAP06","MAP07","MAP08","MAP09","MAP10","MAP11","MAP12","MAP13","MAP14","MAP15","MAP16","MAP17","MAP18","MAP19","MAP20","MAP21","MAP22","MAP23","MAP24","MAP25","MAP26","MAP27","MAP28","MAP29","MAP30","MAP31","MAP32","MAP33","MAP34","MAP35","MAP36","MAP37","MAP38","MAP39","MAP40"}
	},
	{
		name = "Map Hell", 
		file = "hell",
		maps = {"MAPH0", "MAPH1", "MAPH2", "MAPH3", "MAPH4", "MAPH5", "MAPH6", "MAPH7", "MAPH8", "MAPH9", "MAPHA", "MAPHB", "MAPHC", "MAPHD", "MAPHH"}
	},
}

local runtype = 1
local maps = runs[runtype].maps
local names = {}
local run = {}
local runindex
local gmap
local goodexit
local cleanedup
local pbbox
local fuckoff

local splits_mini = CV_RegisterVar({
	name = "splits_mini",
	defaultvalue = "Off",
	flags = CV_NETVAR|CV_CALL,
	possiblevalue = CV_OnOff,
	func = function(var)
		if server then COM_BufAddText(server, "map map01") end
	end
})
local splits_sneakerless = CV_RegisterVar({
	name = "splits_sneakerless",
	defaultvalue = "Off",
	flags = CV_NETVAR|CV_CALL,
	possiblevalue = CV_OnOff,
	func = function(var)
		if server then COM_BufAddText(server, "map map01") end
	end
})
local splits_profile = CV_RegisterVar({
	name = "splits_profile",
	defaultvalue = "",
	flags = CV_NETVAR|CV_CALL,
	possiblevalue = nil,
	func = function(var)
		if server then COM_BufAddText(server, "map map01") end
	end
})
local splits_reset = CV_RegisterVar({
	name = "splits_reset",
	defaultvalue = 2*TICRATE,
	flags = CV_NETVAR,
	possiblevalue = CV_Natural
})

local function savegame()
	I_WriteSaveFile(SAVEFILE, save)
end

-- strip spaces from both sides of strings because jesus christ, mappers, stop with the trailing spaces
local function xtrim(fug)
	return fug:gsub("^(.-)%s*$", "%1")
end

-- used for split times
local function timestring(x)
	if x == nil or x == MAGIC_BULLSHIT then return "--" end
	x = abs(x)
	local tmp = ""
	if x < TICRATE*60 then
		tmp = ""..G_TicsToSeconds(x)..'.'..string.format("%02d", G_TicsToCentiseconds(x))
	elseif x < TICRATE*60*60
		tmp = ""..G_TicsToMinutes(x, true)..":"..string.format("%02d", G_TicsToSeconds(x))..'.'..string.format("%02d", G_TicsToCentiseconds(x))
	else
	tmp = ""..G_TicsToHours(x)..":"..string.format("%02d", G_TicsToMinutes(x))..":"..string.format("%02d", G_TicsToSeconds(x))..'.'..string.format("%02d", G_TicsToCentiseconds(x))
	end
	return tmp:sub(1, #tmp-1)
end

-- used for split deltas
local function deltatimestring(x)
	if x == nil or x == MAGIC_BULLSHIT then return "--" end
	x = abs(x)
	local tmp = ""
	if x < TICRATE*60 then
		tmp = ""..G_TicsToSeconds(x)..'.'..string.format("%02d", G_TicsToCentiseconds(x))
		return tmp:sub(1, #tmp-1)
	else
		tmp = ""..G_TicsToMinutes(x, true)..":"..string.format("%02d", G_TicsToSeconds(x))
		return tmp
	end
end

-- used for overall timer
local function fulltimestring(x)
	if G_TicsToMinutes(x) == 0 and G_TicsToHours(x) == 0 then
		return G_TicsToSeconds(x)..'.'..string.format("%02d", G_TicsToCentiseconds(x))
	elseif G_TicsToHours(x) == 0 then
		return G_TicsToMinutes(x)..":"..string.format("%02d", G_TicsToSeconds(x))..'.'..string.format("%02d", G_TicsToCentiseconds(x))
	else
		return ""..G_TicsToHours(x)..":"..string.format("%02d", G_TicsToMinutes(x))..":"..string.format("%02d", G_TicsToSeconds(x))..'.'..string.format("%02d", G_TicsToCentiseconds(x))
	end
end

-- why do i have to do this?
local function buildmaptitle(map)
	if mapheaderinfo[map].zonttl and xtrim(mapheaderinfo[map].zonttl) != "" then
		return xtrim(mapheaderinfo[map].lvlttl)..xtrim(" "..mapheaderinfo[map].zonttl)
	else
		if mapheaderinfo[map].levelflags & LF_NOZONE then
			return xtrim(mapheaderinfo[map].lvlttl)
		else
			return xtrim(mapheaderinfo[map].lvlttl).." Zone"
		end
	end
end

local function newsave()
	save = {}
	save.pb = {}
	save.pb.time = INT32_MAX -- any new run should be PB
	save.gold = {}
end

local function splits(p, index)
	if not index then
		print("\141Start a new run with \130splits [run #]\141.")
		for k, v in ipairs(runs)
			print("\141#"..k..": "..v.name)
		end
		print("\141If you manually change map, your run will end.")
	elseif index == "nuke"
		if not init then
			print("\141No run active.")
		end
		newsave()
		savegame()
		init = false
		COM_BufAddText(server, "map "..runs[runtype].maps[1])
		print("\141Destroyed saved splits for "..runs[runtype].name..".")
	else
		index = tonumber($)
		if index and index >= 1 and index <= #runs then
			runtype = index
			init = false
			goodexit = true
			COM_BufAddText(server, "map "..runs[runtype].maps[1])
		else
			print("\141Out of range, or not a number.")
		end
	end
end
COM_AddCommand("splits", splits, 1)

local function reset()
	if init then
		COM_BufAddText(server, "splits "..runtype)
	else
		print("\141Tried to reset, but no run was active?")
	end
end

rawset(_G, "Splits_Runs", function()
	return runs
end)
rawset(_G, "Splits_Runtype", function()
	if init then
		return runtype
	else
		return 0
	end
end)
rawset(_G, "Splits_Save", function()
	return save
end)
rawset(_G, "Splits_Reset", function()
	reset()
end)

addHook("ThinkFrame", function()
	if leveltime == 0 then return end
	if not yelled then
		local PATH = "runs.txt"
		local file = io.open(PATH, "r")
		if file != nil then -- CONFIG TIME
			print("\141A custom runs.txt is present! Parsing...")
			local counter = 0
			local runname, runfile
			local buf = file:read()
			while buf
				if buf:sub(1, 1) == "~" then
					local frag = buf:sub(2, #buf)
					print("\141Executing: "..frag)
					COM_BufAddText(server, frag)
				else
					if counter == 0 then
						runname = buf
						print("\141Run name: "..buf)
					elseif counter == 1 then
						runfile = buf
						print("\141Run filename: "..buf)
					elseif counter == 2 then
						local tfile = xtrim(buf)
						if tfile != "" then
							print("\141Adding file: "..tfile)
							COM_BufAddText(server, "addfile "..tfile)
						end
					else
						local tmaps = {}
						local mapstr = ""
						for map in buf:gmatch("%S+") do
							table.insert(tmaps, "MAP"..map)
							mapstr = $ + "MAP"..map.." "
						end
						print('\141Adding run "'..runname..'" with the following maps: '..mapstr)
						table.insert(runs, {name = runname, file = runfile, maps = tmaps})
					end
					counter = ($ + 1) % 4
				end
				buf = file:read()
			end
			file:close()
		end
		print("\141Type \130splits \141in the console to start a run! (Try the ~ key.)")
		yelled = true
	end
	if not init and leveltime == 1 then
		maps = runs[runtype].maps
		if not goodexit then return end
		print("\141New run starting - "..runs[runtype].name)
		run = {}
		run.time = 0
		runindex = 1
		local speedtable = {[0] = "easy", [1] = "normal", [2] = "hard"}
		local runsuf = runs[runtype].file
		local minisuf = splits_mini.value and "-mini" or ""
		local sneaksuf = splits_sneakerless.value and "-sneakerless" or ""
		SAVEFILE = SAVEFILE_BASE..runsuf..minisuf..speedtable[CV_FindVar("kartspeed").value]..sneaksuf..splits_profile.string..SAVEFILE_EXT
		save = I_ReadSaveFile(SAVEFILE)
		if not save then
			newsave()
		end
		for k, v in ipairs(maps) -- make sure we have valid gold splits for every map in the run
			if not save.gold[v] then
				save.gold[v] = INT32_MAX
			end
		end
		pbbox = save.pb
		for i=1,#mapheaderinfo do -- build abbreviated map names
			if mapheaderinfo[i] then
				local name = buildmaptitle(i)
				local lastchar = " "
				local abbr = ""
				for i = 1, #name
					if lastchar == " " then
						abbr = $..name:sub(i, i)
					end
					lastchar = name:sub(i, i)
				end
				names[G_BuildMapName(i)] = abbr
			end
		end
		savegame()
		init = true
	end
	if not init then return end
	local p = consoleplayer
	local mo = p.mo
	local ks = p.kartstuff
	gmap = G_BuildMapName(gamemap)
	if leveltime == 1 then -- per-map init
		fuckoff = 0
		if gmap != maps[runindex] then
			print("\141You're on the wrong map somehow! Run aborted.")
			init = false
		elseif not goodexit then
			print("\141You switched map manually. Run aborted.")
			init = false
		end
		cleanedup = false
		if splits_mini.value then COM_BufAddText(server, "numlaps 1") end
		
		if splits_sneakerless.value then
			p.kartstuff[k_itemamount] = 1
			for thinker in thinkers.iterate("mobj") do
				if thinker and thinker.valid and thinker.type == MT_RANDOMITEM then
					thinker.threshold = 69
					thinker.flags = $|MF2_DONTRESPAWN
					P_RemoveMobj(thinker)
				end
			end
		end
	end
	if not p.exiting then goodexit = false end
	if not init then return end -- if init isn't set here, we're not in a valid run!
	if not (mo and mo.valid) then return end
	if p.spectator then return end
	
	local bt = p.cmd.buttons
	if bt & BT_ACCELERATE and bt & BT_DRIFT and bt & BT_BRAKE and bt & BT_ATTACK then
		fuckoff = $ + 1
		if fuckoff >= splits_reset.value then
			reset()
			fuckoff = 0
		end
	else
		fuckoff = 0
	end
	
	if p.exiting and not cleanedup then -- save gold splits, check for run end, update timers
		run.time = $ + consoleplayer.realtime
		run[runindex] = {}
		run[runindex].segment = consoleplayer.realtime
		run[runindex].total = run.time
		if p.realtime < save.gold[gmap] then
			if save.gold[gmap] == INT32_MAX then
				print("\141First time for "..runs[runtype].name.." (segment "..runindex..") recorded.")
			else
				print("\141Gold split! New best: "..timestring(p.realtime).." - Beats "..timestring(save.gold[gmap]))
			end
			save.gold[gmap] = p.realtime
			run[runindex].gold = true
		end
		runindex = $ + 1
		if runindex > #maps then
			print("\141Run over!")
			if run.time < save.pb.time then
				save.pb = run
				if pbbox.time == INT32_MAX then
					print("\141First PB for "..runs[runtype].name.." recorded. Now smash it!")
				else
					print("\141NEW PB: "..fulltimestring(run.time).." - beats "..fulltimestring(pbbox.time))
				end
			end
		end
		savegame()
		cleanedup = true
	end
	if p.exiting == 8 and cleanedup then -- advance or hold?
		if runindex > #maps then
			p.exiting = 10
		else
			goodexit = true
			COM_BufAddText(server, "map "..maps[runindex])
		end
	end
end)

hud.add(function(v, p, c)
	hud.disable("freeplay")
	if not init then return end
	local X1 = 230
	local X2 = 315
	local Y1 = 140
	local Y2 = 195
	local PAD = 5
	local FLAGS = V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_ALLOWLOWERCASE
	if run.time == nil then return end
	local lastflag = 0
	local row = 0
	
	local TFLAGS = V_SNAPTOTOP|V_SNAPTORIGHT|V_ALLOWLOWERCASE|V_HUDTRANS
	local adjrunindex = (consoleplayer.exiting) and (runindex-1) or (runindex)
	local pbtime = (pbbox[adjrunindex] and pbbox[adjrunindex].segment) and timestring(pbbox[adjrunindex].segment) or "--"
	local goldtime = (save.gold[gmap] != INT32_MAX) and timestring(save.gold[gmap]) or "--"
	v.drawString(300, 7, "GOLD: "..goldtime.."     PB: "..pbtime, TFLAGS, "small-right")
	
	if fuckoff > 8 then
		local yb = 5
		v.drawString(160, yb, "RESET?", V_20TRANS, "center")
		local bw = 50
		local bh = 5
		v.drawFill(160-bw/2, yb+10, bw, bh, 31)
		v.drawFill(160-bw/2+1, yb+11, fuckoff * (bw-2) / splits_reset.value, bh-2, 133)
	end
	
	--v.drawString(X1, Y1-7, runs[runtype].name, FLAGS|V_30TRANS, "small")
	local skipflag = 0
	for key, val in ipairs(maps)
		local rows = ((Y2-Y1-10)/PAD)
		local topoff = min(#maps-rows+1, max(runindex-rows+3, 0))
		if key < topoff then continue end
		if row == rows-1 and key != #maps then
			skipflag = V_50TRANS
			continue
		end
		row = $ + 1
		if row > rows then continue end
		local YB = Y1 + PAD * (row - 1)
		if runindex <= #maps and runindex == key then
			v.drawFill(X1-1, Y1 + PAD * (row - 1) - 1, X2-X1+2, 6, 255|FLAGS)
		end
		v.drawString(X1 + 8, YB, names[val], FLAGS|skipflag, "small")
		v.drawScaled((X1+7)*FRACUNIT, YB*FRACUNIT, FRACUNIT/26, v.cachePatch(val.."P"), FLAGS|skipflag)
		local rectime = nil
		local recflags = 0
		if run[key] then
			rectime = run[key].total
		elseif pbbox[key] then
			rectime = pbbox[key].total
		end
		local recoff = v.stringWidth(timestring(rectime), FLAGS|recflags, "small")
		local disptime
		local dispflags = 0
		if pbbox[key] then
			if run[key] then
				disptime = run[key].total - pbbox[key].total
			elseif key == runindex and not consoleplayer.exiting then
				disptime = run.time + consoleplayer.realtime - pbbox[key].total
			end
		end
		if disptime != nil then
			local pref = ""
			if disptime < 0 then
				dispflags = V_SKYMAP
				pref = "-"
			elseif disptime > 0 then 
				dispflags = V_REDMAP
				pref = "+"
				if key == runindex then
					lastflag = V_REDMAP
				end
			end
			if key < runindex and runindex > 1 then
				lastflag = dispflags
			end
			if run[key] and run[key].gold then
				dispflags = V_YELLOWMAP
			end
			v.drawString(X2 - recoff - 5, YB, pref..deltatimestring(disptime), FLAGS|dispflags|skipflag, "small-right")
		end
		v.drawString(X2, YB, timestring(rectime), FLAGS|recflags|skipflag, "small-right")
	end
	local showtime = run.time + p.realtime
	if consoleplayer.exiting then showtime = run.time end
	if runindex > #maps and consoleplayer.exiting then
		if (pbbox and pbbox.time > run.time) or (not pbbox) then lastflag = V_YELLOWMAP end
	end
	v.drawString(X2, Y2-10, fulltimestring(showtime), FLAGS|lastflag, "right")
end)